     package vaft.core;

     import java.net.MalformedURLException;
     import java.rmi.*;
     import java.rmi.server.*;

     /*********************************************************************
     * <P>
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   1998-03-15
     *********************************************************************/

     public class  Host extends UnicastRemoteObject
       implements Context, HostRemote
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private AgentList  agentList = new AgentList ( );
     private PeerList   peerList;

     //////////////////////////////////////////////////////////////////////
     // Constructor methods
     //////////////////////////////////////////////////////////////////////

     public  Host ( PeerList  peerList ) throws RemoteException
     //////////////////////////////////////////////////////////////////////
     {
       this.peerList = peerList;
       ( new Thread ( peerList ) ).start ( );
     }

     //////////////////////////////////////////////////////////////////////
     // RMI methods
     //////////////////////////////////////////////////////////////////////

     public void  host ( Agent  agent ) throws RemoteException
     //////////////////////////////////////////////////////////////////////
     {
       agentList.host ( agent, this );
     }

     public PeerList  swap ( PeerList  peerList ) throws RemoteException
     //////////////////////////////////////////////////////////////////////
     {
       return this.peerList.swap ( peerList );
     }

     //////////////////////////////////////////////////////////////////////
     // Context methods
     //////////////////////////////////////////////////////////////////////

     /** Returns a clone. */
     public PeerList  getPeerList ( )
     //////////////////////////////////////////////////////////////////////
     {
       return ( PeerList ) peerList.clone ( );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
