     package vaft.tutorial;

     import java.net.*;
     import java.rmi.*;
     import java.util.*;

     /*********************************************************************
     * <P>
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   1998-03-08
     *********************************************************************/

     public class  Launcher {
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public static final String  DEFAULT_FILE_SERVER_ROOT
       = "V:\\java\\classes\\";
     public static final String  DEFAULT_AGENT_CLASS_NAME
       = "vaft.tutorial.CountAgent";
     public static final String  DEFAULT_HOST_SERVER_NAME = "localhost";
     public static final String  DEFAULT_FILE_SERVER_PORT = "1968";

     private static final String  CODEBASE_PROPERTY
       = "java.rmi.server.codebase";

     //////////////////////////////////////////////////////////////////////
     // Static methods
     //////////////////////////////////////////////////////////////////////

     public static void  main ( String [ ]  args )
       throws ClassNotFoundException,
              IllegalAccessException,
              InstantiationException,
              MalformedURLException,
              NotBoundException,
              RemoteException,
              java.net.UnknownHostException,
              java.rmi.UnknownHostException
     //////////////////////////////////////////////////////////////////////
     {
       String  host_server_name = DEFAULT_HOST_SERVER_NAME;
       String  host_object_name = HostRemote.DEFAULT_HOST_OBJECT_NAME;
       String  agent_class_name = DEFAULT_AGENT_CLASS_NAME;
       String  file_server_root = DEFAULT_FILE_SERVER_ROOT;
       String  file_server_port = DEFAULT_FILE_SERVER_PORT;

       if ( args.length > 0 ) host_server_name = args [ 0 ];
       if ( args.length > 1 ) host_object_name = args [ 1 ];
       if ( args.length > 2 ) agent_class_name = args [ 2 ];
       if ( args.length > 3 ) file_server_root = args [ 3 ];
       if ( args.length > 4 ) file_server_port = args [ 4 ];

       int  file_server_port_num = Integer.parseInt ( file_server_port );

       FileServer  fileServer = null;

       Properties  properties = System.getProperties ( );
System.out.println ( System.getProperty ( CODEBASE_PROPERTY ) );
       if ( System.getProperty ( CODEBASE_PROPERTY ) == null )
       {
         InetAddress  inetAddress = InetAddress.getLocalHost ( );
         properties.put ( CODEBASE_PROPERTY,
           "http://" + inetAddress.getHostAddress ( ) + ":"
           + file_server_port_num + "/" );
         fileServer = new FileServer (
           file_server_root, file_server_port_num );
         new Thread ( fileServer ).start ( );
       }
System.out.println ( System.getProperty ( CODEBASE_PROPERTY ) );
       

       try {
         launch ( host_server_name, host_object_name, agent_class_name );
       }
       finally {
         try { fileServer.shutdown ( ); } catch ( Exception  e ) { }
       }
     }

     public static void  launch
     (
       String  host_server_name,
       String  host_object_name,
       String  agent_class_name
     )
     throws ClassNotFoundException,
            IllegalAccessException,
            InstantiationException,
            MalformedURLException,
            NotBoundException,
            RemoteException,
            java.rmi.UnknownHostException
     //////////////////////////////////////////////////////////////////////
     {
       Class  c = Class.forName ( agent_class_name );
       Agent  agent = ( Agent ) c.newInstance ( );
       String  rmi_url = "//" + host_server_name + "/" + host_object_name;
       HostRemote  hostRemote = ( HostRemote ) Naming.lookup ( rmi_url );
       hostRemote.host ( agent );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
